/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2023-03-29
* Changed:         2024-05-31
*
* */

#ifndef LS_STD_DATE_PARAMETER_HPP
#define LS_STD_DATE_PARAMETER_HPP

#include <ls-std/core/definition.hpp>
#include <ls-std/time/type/DateParameterTypes.hpp>

namespace ls::std::time
{
  ls_std_class DateParameter
  {
    public:

      DateParameter(type::Year _year, type::Month _month, type::Day _day, type::Hour _hour, type::Minute _minute, type::Second _second);
      DateParameter();
      ~DateParameter();

      bool operator==(const DateParameter &_dateParameter) const;

      [[nodiscard]] type::Day getDay() const;
      [[nodiscard]] type::Hour getHour() const;
      [[nodiscard]] type::Minute getMinute() const;
      [[nodiscard]] type::Month getMonth() const;
      [[nodiscard]] type::Second getSecond() const;
      [[nodiscard]] type::Year getYear() const;
      void setDay(type::Day _day);
      void setHour(type::Hour _hour);
      void setMinute(type::Minute _minute);
      void setMonth(type::Month _month);
      void setSecond(type::Second _second);
      void setYear(type::Year _year);

    private:

      type::Day day{};
      type::Hour hour{};
      type::Minute minute{};
      type::Month month{};
      type::Second second{};
      type::Year year{};
  };
}

#endif
