/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2023-03-15
* Changed:         2024-05-31
*
* */

#ifndef LS_STD_SYSTEM_TIME_PARAMETER_HPP
#define LS_STD_SYSTEM_TIME_PARAMETER_HPP

#include "IClock.hpp"
#include <ls-std/core/definition.hpp>
#include <memory>

namespace ls::std::time
{
  ls_std_class SystemTimeParameter
  {
    public:

      SystemTimeParameter();
      ~SystemTimeParameter();

      [[nodiscard]] ::std::shared_ptr<IClock> getClock() const;
      void setClock(const ::std::shared_ptr<IClock> &_clock);

    private:

      ::std::shared_ptr<IClock> clock{};
  };
}

#endif
